#include "sync.h"

void sync_init(sync_t *s, int n)
{
    sem_init(&s->m, 0, 1);
    sem_init(&s->s[0], 0, 0);
    sem_init(&s->s[1], 0, 0);
    s->turn = 0;
    s->nblocked[0] = 0;
    s->nblocked[1] = 0;
    s->nthreads = n;

}

void sync_wait(sync_t *s)
{
    int myturn;
    int i;
    sem_wait(&s->m);
    myturn = s->turn;
    s->nblocked[myturn]++;
    if (s->nblocked[myturn] < s->nthreads) {
        sem_post(&s->m);
        sem_wait(&s->s[myturn]);
    } else {
        for(i=0;i<s->nthreads-1; i++) 
            sem_post(&s->s[myturn]);
        s->nblocked[myturn] = 0;
        s->turn ^= 0x01;
        sem_post(&s->m);
    }
    return;
}

