#include "sync.h"

void *thread_body(void *arg)
{
  sync_t *psync = (sync_t *)arg;
  int delay = rand() % 4;

  sleep(delay);

  printf("%d sec: Before the synchronization point...\n", delay);

  sync_wait(psync);

  printf("After the synchronization point!\n");

  return 0;
}


int main(int argc, char *argv[])
{
  pthread_t *array;
  int i;

  if (argc < 2) {
    printf("Usage: %s <nthreads>\n", argv[0]);
    exit(0);
  }
  int n = atoi(argv[1]);
  printf("Example with %d threads\n", n);
  
  array = (pthread_t *)malloc(sizeof(pthread_t) * n);

  sync_t my_synch;
  sync_init(&my_synch, n);

  for(i=0; i<n; i++) 
    pthread_create(&array[i], 0, thread_body, (void *)(&my_synch));
  
  for (i=0; i<n; i++) 
    pthread_join(array[i], 0);

  return 0;

}
