#include "sync_mon.h"

sync_t mysync;

void *thread_body(void *arg)
{
    int index = *((int*)arg);
    int i = 0;

    for (i=0; i<10; i++) {
        sync_wait(&mysync);
        printf("Thread %d, After %d-A\n", index, i);
        sync_wait(&mysync);
        printf("Thread %d, After %d-B\n", index, i);
    }
    return 0;
}


int main(int argc, char *argv[])
{
    pthread_t *array;
    int *indexes;
    int i;

    if (argc < 2) {
        printf("Usage: %s <nthreads>\n", argv[0]);
        exit(0);
    }
    int n = atoi(argv[1]);
    printf("Example with %d threads\n", n);
  
    array = (pthread_t *)malloc(sizeof(pthread_t) * n);
    indexes = (int *)malloc(sizeof(int) * n);

    sync_init(&mysync, n);

    for(i=0; i<n; i++) {
        indexes[i] = i;
        pthread_create(&array[i], 0, thread_body, (void *)(&indexes[i]));
    }  
  
    for (i=0; i<n; i++) 
        pthread_join(array[i], 0);

    return 0;

}
