#include "sync_mon.h"

void sync_init(sync_t *s, int n)
{
    pthread_mutex_init(&s->m, 0);
    pthread_cond_init(&s->c, 0);
    s->nblocked = 0;
    s->nthreads = n;

}

void sync_wait(sync_t *s)
{
    pthread_mutex_lock(&s->m);
    s->nblocked++;
    if (s->nblocked < s->nthreads) 
        pthread_cond_wait(&s->c, &s->m);
    else {
        pthread_cond_broadcast(&s->c);
        s->nblocked = 0;
    }
    pthread_mutex_unlock(&s->m);

    return;
}

