#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

sem_t sa;

void *thread_a(void *arg)
{
    sleep(1);

    printf("Thread A: before synchronization\n");

    sem_wait(&sa);

    printf("Thread A: after synchronization\n");

    return 0;
}


void *thread_b(void *arg)
{
    //sleep(1);

    printf("Thread B: before synchronization\n");

    sem_post(&sa);

    printf("Thread B: after synchronization\n");

    return 0;
}

int main()
{
    pthread_t ta, tb;

    sem_init(&sa, 0, 0);

    pthread_create(&ta, 0, thread_a, 0);
    pthread_create(&tb, 0, thread_b, 0);

    pthread_join(ta, 0);
    pthread_join(tb, 0);

    return 0;
}
